-- name: [CS] Violet's Sonic Pack
-- description: Mr. Needlehouse, and his friend who carries a large hammer, have arrived in the Mushroom Kingdom, you can now play as Sonic the Hedgehog and Amy Rose in this cute and simple mod including my versions of Sonic and Amy in the SM64 world!\n\nMade by: VioletArts\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- Replace Mod Name with your Character/Pack name.
local TEXT_MOD_NAME = "Violet's Sonic Pack"

-- Stops mod from loading if Character Select isn't on, Does not need to be touched
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_AMY =      smlua_model_util_get_id("amy_violet_geo")
local E_MODEL_SONIC =      smlua_model_util_get_id("sonic_violet_geo")      -- Located in "actors"

local TEX_AMY_LIFE_ICON = get_texture_info("amy_violet_icon")
local TEX_SONIC_LIFE_ICON = get_texture_info("sonic_violet_icon") -- Located in "textures"

local VOICETABLE_AMY = {
    [CHAR_SOUND_OKEY_DOKEY] =        'AmyOkeyDokie.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'AmyLetsGo.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'AmyYah.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'AmyWah.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'AmyHoo.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'AmyYah.ogg', 'AmyWah.ogg', 'AmyHoo.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'AmyHoohoo.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'AmyWaha.ogg', 'AmyYippee.ogg','AmyYahoo.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'AmyUh.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'AmyUh.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'AmyUh.ogg',
	[CHAR_SOUND_HAHA] =              'AmyHaha.ogg',
    [CHAR_SOUND_HAHA_2] =            'AmyHaha.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'AmyYahoo.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'AmyDoh.ogg', -- Long jump wall bonk
    [CHAR_SOUND_OOOF] =              'AmyOof.ogg',
    [CHAR_SOUND_OOOF2] =             'AmyOof.ogg',
	[CHAR_SOUND_WHOA] =              'AmyWoah.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'AmyEeuh.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] =          'AmyFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] =      'AmyBoing.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'AmyWah.ogg', 
	[CHAR_SOUND_HRMM] =              'AmyHrmm.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'AmyHereWeGo.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'AmyBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'AmyDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'AmyPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'AmyPanting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'AmyBurning.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'AmyImTired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'AmyYawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'AmySnore1.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'AmySnore2.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'AmySnore3.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'AmyCough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'AmyCough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'AmyCough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'AmyDead.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'AmyDrowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'AmyOhNo.ogg' -- Booted out of level
}

local VOICETABLE_SONIC = {
    [CHAR_SOUND_OKEY_DOKEY] =        'SonicOkeyDokey.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'SonicLetsGo.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'SonicYah.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'SonicWah.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'SonicKick.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'SonicYah.ogg', 'SonicWah.ogg', 'SonicKick.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'SonicHooHoo.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'SonicWaha.ogg', 'SonicYippee.ogg','SonicYahoo.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'SonicUh.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'SonicUh.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'SonicUh.ogg',
	[CHAR_SOUND_HAHA] =              'SonicHaha.ogg',
    [CHAR_SOUND_HAHA_2] =            'SonicHaha.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'SonicYahoo.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'SonicDoh.ogg', -- Long jump wall bonk
    [CHAR_SOUND_OOOF] =              'SonicOof.ogg',
    [CHAR_SOUND_OOOF2] =             'SonicOof.ogg',
	[CHAR_SOUND_WHOA] =              'SonicWoah.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'SonicEeuh.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] =          'SonicFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] =      'SonicBoing.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'SonicWah.ogg', 
	[CHAR_SOUND_HRMM] =              'SonicHrmm.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'SonicHereWeGo.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'SonicBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'SonicAttacked.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'SonicPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'SonicPanting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'SonicBurning.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'SonicImTired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'SonicYawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'SonicSnore1.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'SonicSnore2.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'SonicSnore3.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'SonicCough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'SonicCough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'SonicCough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'SonicDead.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'SonicDrowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'SonicMamaMia.ogg' -- Booted out of level
}

local PALETTE_AMY = {
    [PANTS]  = "6B6B6B",
    [SHIRT]  = "FF002E",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FF002E",
    [HAIR]   = "FFA3DF",
    [SKIN]   = "FEC179",
    [CAP]    = "FF002E",
	[EMBLEM] = "FFB32A"
}

local PALETTE_SONIC = {
    [PANTS]  = "696969",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FF001E",
    [HAIR]   = "0F46FF",
    [SKIN]   = "FEC179",
    [CAP]    = "0F46FF",
}

local AMY_CAPMODELS = {
    normal = smlua_model_util_get_id("amy_violet_cap_geo"),
    wing = smlua_model_util_get_id("amy_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("amy_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("amy_violet_cap_metal_wing_geo"),
}

local SONIC_CAPMODELS = {
    normal = smlua_model_util_get_id("sonic_violet_cap_geo"),
    wing = smlua_model_util_get_id("sonic_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("sonic_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("sonic_violet_cap_metal_wing_geo"),
}

local HEALTH_METER_SONIC = {
    label = {
        left = get_texture_info("SonicLeft"),
        right = get_texture_info("SonicRight"),
    },
    pie = {
        [1] = get_texture_info("SonicPie-1"),
        [2] = get_texture_info("SonicPie-2"),
        [3] = get_texture_info("SonicPie-3"),
        [4] = get_texture_info("SonicPie-4"),
        [5] = get_texture_info("SonicPie-5"),
        [6] = get_texture_info("SonicPie-6"),
        [7] = get_texture_info("SonicPie-7"),
        [8] = get_texture_info("SonicPie-8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    -- Adds the custom character to the Character Select Menu
    CT_SONIC = _G.charSelect.character_add(
        "Sonic The Hedgehog", -- Character Name
        "Some call him faster than the speed of light, some call him a legend, but for him, he is the fastest thing alive as Sonic the Hedgehog has arrived in Mario's place to stop Bowser's reign.", -- Description
        "VioletArts", -- Credits
        "0F46FF",           -- Menu Color
        E_MODEL_SONIC,       -- Character Model
        CT_MARIO,           -- Override Character
        TEX_SONIC_LIFE_ICON, -- Life Icon
        1,                  -- Camera Scale
        0                   -- Vertical Offset
    )

    CT_AMY = _G.charSelect.character_add(
        "Amy Rose", -- Character Name
        "The pink hedgehog with a passion for Sonic, followed him to the Mushroom Kingdom, with her trusty Piko-Piko Hammer, nothing stands in her way. Never fear, Amy Rose is here!", -- Description
        "VioletArts", -- Credits
        "FFA3DF",           -- Menu Color
        E_MODEL_AMY,       -- Character Model
        CT_MARIO,           -- Override Character
        TEX_AMY_LIFE_ICON, -- Life Icon
        1,                  -- Camera Scale
        0                   -- Vertical Offset
    )

    _G.charSelect.character_add_voice(E_MODEL_AMY, VOICETABLE_AMY)
    _G.charSelect.character_add_voice(E_MODEL_SONIC, VOICETABLE_SONIC)

	_G.charSelect.character_add_caps(E_MODEL_AMY, AMY_CAPMODELS)
    _G.charSelect.character_add_caps(E_MODEL_SONIC, SONIC_CAPMODELS)

    _G.charSelect.character_add_palette_preset(E_MODEL_AMY, PALETTE_AMY)
    _G.charSelect.character_add_palette_preset(E_MODEL_SONIC, PALETTE_SONIC)

    _G.charSelect.character_add_health_meter(CT_SONIC, HEALTH_METER_SONIC)
    _G.charSelect.character_add_health_meter(CT_SONIC, HEALTH_METER_SONIC)

    _G.charSelect.credit_add(TEXT_MOD_NAME, "VioletArts", "Pack")
	_G.charSelect.credit_add(TEXT_MOD_NAME, "Emzberry", "Amy Voice Actor")
	_G.charSelect.credit_add(TEXT_MOD_NAME, "Boost", "Sonic Voice Actor")

    CSloaded = true
end

function geo_sonic_shoe_wing(node, matStackIndex)
    local marioBodyStateValue = geo_get_body_state()
    if (marioBodyStateValue.capState & 2 ~= 0) then
        node.children.flags = node.children.flags | GRAPH_RENDER_ACTIVE
    else
        node.children.flags = node.children.flags & ~GRAPH_RENDER_ACTIVE
    end
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_AMY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SONIC then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_AMY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SONIC then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)